<?php
namespace Teknisa\EST\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;

class Est56000EstoqueMinimoProdutoController extends \Teknisa\EST\Controllers\TeknisaCrud {
    
    protected $dataSourceName;
    
    public function __construct($crudService, $parameterBag, $dataSourceManager, $enviroment) {
        parent::__construct($crudService, $parameterBag);
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $enviroment;
    }
   
    public function saveEstqMinProd(DTO\Request $request, DTO\Response $response) {
        try {
            $this->dataSourceName ='prodfili_produto_estqmin';
            $this->dataSourceNameToSave = 'prodfili_produto_estqmin';
            parent::save($request,$response);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    public function saveEstqMinProdAlmox(DTO\Request $request, DTO\Response $response) {
        try {
            $rowToSave = $this->adicionaCampos($request->getRow());
            $rowsToSave = array($rowToSave);
            $dataSet = new DataSet('prodfilialmox', $rowsToSave);
            $this->dataSourceManager->persist($dataSet);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function setIsNew($row) {
        $conditions = array(
          array(
            "value" => $row['CDFILIAL'],
            "operator" => "=",
            "columnName" => "CDFILIAL"
          ),
          array(
            "value" => $row['CDALMOXARIFE'],
            "operator" => "=",
            "columnName" => "CDALMOXARIFE"
          ),
          array(
            "value" => $row['CDPRODUTO'],
            "operator" => "=",
            "columnName" => "CDPRODUTO"  
          )
        );
        $result = $this->realizaConsultaBanco('prodfilialmox', $conditions);
        if(isset($result->getRows()[0])) $row['__is_new'] = false;
        else $row['__is_new'] = true;
        return $row;
    }

    public function realizaConsultaBanco($dataSourceName, $conditions) {
        $filterCriteria = new FilterCriteria($dataSourceName,$conditions);
        $dataSet = $this->dataSourceManager->findBy($filterCriteria);
        return $dataSet;
    }
     
    protected function adicionaCampos($row) {
        $nrorg = $this->environment->getNrorgTrab();
		$operador = $this->environment->getCdOperador();
		$currentTime = $this->environment->getCurrentTime()->format("d/m/Y H:i:s");
		$row['NRORG'] = $nrorg;
		$row['DTINCLUSAO'] = $currentTime;
		$row['DTULTATU'] = $currentTime;
		$row['CDOPERINCLUSAO'] = $operador;
		$row['CDOPERULTATU'] = $operador;
		$row['IDATIVO'] = 'S';
		$row['NRORGINCLUSAO'] = $nrorg;
		$row['NRORGULTATU'] = $nrorg;
		$row = $this->setIsNew($row);
		return $row;
    }
}